#!/usr/bin/env python

def e(x): pass

class C:
    e = e

    def test(self):
        self.e()

class D:
    e = C.e

    def test(self):
        self.e(1) # TypeError: unbound C.e needs C instance, not int

class E(C):
    def test(self):
        self.e()

c = C()
d = D()
e = E()

p = c.e # bound C.e
q = d.e # unbound C.e
r = e.e # bound E.e

# vim: tabstop=4 expandtab shiftwidth=4
